//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Yellow
#property indicator_color4  Yellow
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern double BullBearPeriod = 13;
extern int    BullBearPrice  = 0;
extern double uptradeLvl     = 0.0025;
extern double dntradeLvl     = -0.0025;

//
//
//
//
//

double upDot[];
double dnDot[];
double upCau[];
double dnCau[];
double bulls[];
double bears[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(8); 
   SetIndexBuffer(0,upDot); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108);
   SetIndexBuffer(1,dnDot); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108);
   SetIndexBuffer(2,upCau); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,dnCau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);  
   SetIndexBuffer(4,bulls);
   SetIndexBuffer(5,bears);
   SetIndexBuffer(6,trend1);
   SetIndexBuffer(7,trend2);
   
return(0);
}

//
//
//
//
//

int deinit()
{    
return(0); 
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
     for (i=limit; i>=0; i--)
     { 
        bulls[i] = High[i] - iMA(NULL,0,BullBearPeriod,0,MODE_SMA,BullBearPrice,i);
        bears[i] = Low[i]  - iMA(NULL,0,BullBearPeriod,0,MODE_SMA,BullBearPrice,i);
        upDot[i] = EMPTY_VALUE;
        dnDot[i] = EMPTY_VALUE;
        upCau[i] = EMPTY_VALUE;
        dnCau[i] = EMPTY_VALUE;
        trend1[i] = 0;
        trend2[i] = 0;
           if (bulls[i] > uptradeLvl && bears[i] > uptradeLvl) trend1[i] = 1;
           if (bears[i] < dntradeLvl && bulls[i] < dntradeLvl) trend1[i] =-1;
           if (bulls[i] > uptradeLvl && bears[i] < uptradeLvl) trend2[i] = 1;
           if (bears[i] < dntradeLvl && bulls[i] > dntradeLvl) trend2[i] =-1;
           if (trend1[i]== 1) upDot[i] = High[i]+3.0*iATR(NULL,0,10,i)/4.0; 
           if (trend1[i]==-1) dnDot[i] = Low[i] -3.0*iATR(NULL,0,10,i)/4.0; 
           if (trend2[i]== 1) upCau[i] = High[i]+3.0*iATR(NULL,0,10,i)/4.0; 
           if (trend2[i]==-1) dnCau[i] = Low[i] -3.0*iATR(NULL,0,10,i)/4.0; 
     }
return(0);
}
   
   